<?php
declare(strict_types=1);

use Migrations\AbstractMigration;

/**
 * Class Transfer
 *
 * Created via:
 * oitc migrations create -p DistributeModule Transfer
 *
 * Run migration:
 * oitc migrations migrate -p DistributeModule
 *
 */
class Transfer extends AbstractMigration {
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * https://book.cakephp.org/phinx/0/en/migrations.html#the-change-method
     * @return void
     */
    public function change(): void {

        $this->table('satellites')
            ->addColumn('login', 'string', [
                'limit' => 255,
                'null'  => true,
            ])
            ->addColumn('port', 'integer', [
                'default' => null,
                'limit'   => 11,
                'null'    => true,
            ])
            ->addColumn('private_key_path', 'string', [
                'limit' => 255,
                'null'  => true,
            ])
            ->addColumn('url', 'string', [
                'limit' => 255,
                'null'  => true,
            ])
            ->addColumn('remote_port', 'integer', [
                'default' => null,
                'limit'   => 11,
                'null'    => true,
            ])
            ->addColumn('api_key', 'string', [
                'limit' => 255,
                'null'  => true,
            ])
            ->addColumn('interval', 'integer', [
                'default' => null,
                'limit'   => 11,
                'null'    => true,
            ])
            ->addColumn('timeout', 'integer', [
                'default' => null,
                'limit'   => 11,
                'null'    => true,
            ])
            ->update();
    }
}
