<?php
declare(strict_types=1);

use Migrations\AbstractMigration;

/**
 * Class NstaExport
 *
 * Created via:
 * oitc migrations create -p DistributeModule NstaExport
 *
 * Run migration:
 * oitc migrations migrate -p DistributeModule
 *
 */
class NstaExport extends AbstractMigration {

    /**
     * Whether the tables created in this migration
     * should auto-create an `id` field or not
     *
     * This option is global for all tables created in the migration file.
     * If you set it to false, you have to manually add the primary keys for your
     * tables using the Migrations\Table::addPrimaryKey() method
     *
     * @var bool
     */
    public $autoId = false;

    /**
     * Change Method.
     *
     * More information on this method is available here:
     * https://book.cakephp.org/phinx/0/en/migrations.html#the-change-method
     * @return void
     */
    public function change(): void {

        $this->table('satellite_status')
            ->addColumn('satellite_id', 'integer', [
                'default' => null,
                'null'    => false
            ])
            ->addIndex(['satellite_id'], ['unique' => false])
            ->update();

        $this->table('satellites')
            ->addColumn('nsta_sync_instance', 'integer', [
                'default' => 0,
                'limit'   => 1,
                'null'    => false
            ])
            ->update();

    }
}
