<?php
declare(strict_types=1);

namespace DistributeModule\Model\Entity;

use Cake\ORM\Entity;

/**
 * SatelliteTask Entity
 *
 * @property int $id
 * @property string $task
 * @property int $status
 * @property string $result
 * @property string $error
 * @property \Cake\I18n\FrozenTime $modified
 * @property \Cake\I18n\FrozenTime $created
 * @property int $satellite_id
 *
 * @property \DistributeModule\Model\Entity\Satellite $satellite
 */
class SatelliteTask extends Entity {

    public const SatelliteTaskUnknown = 0;
    public const SatelliteTaskQueued = 1 << 0; // 1
    public const SatelliteTaskRunning = 1 << 1; // 2
    public const SatelliteTaskFinishedSuccessfully = 1 << 2; // 4
    public const SatelliteTaskFinishedError = 1 << 3; // 8
    public const SatelliteTaskAborted = 1 << 4; // 16

    /**
     * Fields that can be mass assigned using newEntity() or patchEntity().
     *
     * Note that when '*' is set to true, this allows all unspecified fields to
     * be mass assigned. For security purposes, it is advised to set '*' to false
     * (or remove it), and explicitly make individual fields accessible as needed.
     *
     * @var array
     */
    protected $_accessible = [
        'task'         => true,
        'status'       => true,
        'result'       => true,
        'error'        => true,
        'modified'     => true,
        'created'      => true,
        'satellite_id' => true,
        'satellite'    => true,
    ];
}
