<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

$timezones = \itnovum\openITCOCKPIT\Core\Timezone::listTimezones();
$SatSyncMethods = new \DistributeModule\Lib\SatSyncMethods();
?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?php echo __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fas fa-puzzle-piece"></i> <?php echo __('Distribute Module'); ?>
    </li>
    <li class="breadcrumb-item">
        <a ui-sref="SatellitesIndex">
            <i class="fas fa-satellite"></i> <?php echo __('Satellites'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fa fa-edit"></i> <?php echo __('Edit'); ?>
    </li>
</ol>


<div class="row">
    <div class="col-xl-12">
        <div id="panel-1" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('Edit satellite:'); ?>
                    <span class="fw-300"><i>{{post.Satellite.name}}</i></span>
                </h2>
                <div class="panel-toolbar">
                    <div class="text-muted cursor-default d-none d-sm-none d-md-none d-lg-block margin-right-10">
                        <?= __('ID'); ?>: {{ post.Satellite.id }}
                    </div>
                    <?php if ($this->Acl->hasPermission('index', 'satellites', 'DistributeModule')): ?>
                        <a back-button href="javascript:void(0);" fallback-state='SatellitesIndex'
                           class="btn btn-default btn-xs mr-1 shadow-0">
                            <i class="fas fa-long-arrow-alt-left"></i> <?php echo __('Back'); ?>
                        </a>
                    <?php endif; ?>
                </div>
            </div>
            <div class="panel-container show">
                <div class="panel-content">
                    <form ng-submit="submit();" class="form-horizontal"
                          ng-init="successMessage=
            {objectName : '<?php echo __('Satellite'); ?>' , message: '<?php echo __('saved successfully'); ?>'}">

                        <div class="form-group required" ng-class="{'has-error': errors.container_id}">
                            <label class="control-label" for="SatelliteContainer">
                                <?php echo __('Container'); ?>
                            </label>
                            <select
                                    data-placeholder="<?php echo __('Please choose'); ?>"
                                    class="form-control"
                                    chosen="containers"
                                    id="SatelliteContainer"
                                    ng-options="container.key as container.value for container in containers"
                                    ng-model="post.Satellite.container_id">
                            </select>
                            <div ng-repeat="error in errors.container_id">
                                <div class="help-block text-danger">{{ error }}</div>
                            </div>
                        </div>

                        <div class="form-group required" ng-class="{'has-error':errors.name}">
                            <label class="control-label">
                                <?php echo __('Satellite Name'); ?>
                            </label>
                            <input
                                    ng-model="post.Satellite.name"
                                    class="form-control"
                                    maxlength="255"
                                    type="text"
                                    id="SatelliteName">
                            <div ng-repeat="error in errors.name">
                                <div class="help-block text-danger">{{ error }}</div>
                            </div>
                        </div>

                        <div class="form-group required" ng-class="{'has-error':errors.address}">
                            <label class="control-label">
                                <?php echo __('IP address'); ?>
                            </label>
                            <input
                                    ng-model="post.Satellite.address"
                                    class="form-control"
                                    maxlength="255"
                                    type="text"
                                    id="SatelliteAddress">
                            <div ng-repeat="error in errors.address">
                                <div class="help-block text-danger">{{ error }}</div>
                            </div>
                            <div class="help-block">
                                <?php echo __('This address will be used for all communications between the master instance and the satellite system.'); ?>
                            </div>
                        </div>

                        <div class="form-group required" ng-class="{'has-error': errors.sync_method}">
                            <label class="control-label" for="SatelliteSyncMethod">
                                <?php echo __('Synchronisation method'); ?>
                            </label>
                            <select
                                    data-placeholder="<?php echo __('Please choose'); ?>"
                                    class="form-control"
                                    chosen="{}"
                                    id="SatelliteSyncMethod"
                                    ng-model="post.Satellite.sync_method">
                                <?php foreach ($SatSyncMethods->getSyncMethods() as $key => $name): ?>
                                    <option value="<?php echo h($key); ?>"><?php echo h($name); ?></option>
                                <?php endforeach; ?>
                            </select>
                            <div ng-repeat="error in errors.sync_method">
                                <div class="help-block text-danger">{{ error }}</div>
                            </div>
                            <div class="help-block">
                                <?= __('HTTPS Push: The Satellite System will push check results to the Master system and frequently check for configuration changes.') ?>
                                <br/>
                                <?= __('HTTPS Pull: The Mastersystem will frequently pull check results from the Satellite and push configuration changes.') ?>
                                <br/>
                                <?= __('SSH: The Mastersystem will create an SSH tunnel to the Satellite system and pull check results and push configuration changes.') ?>
                            </div>
                        </div>

                        <div ng-switch="post.Satellite.sync_method">
                            <div ng-switch-when="ssh">
                                <div class="form-group required" ng-class="{'has-error':errors.login}">
                                    <label class="control-label" for="Login">
                                        <?php echo __('Login'); ?>
                                    </label>
                                    <input ng-model="post.Satellite.login"
                                           class="form-control"
                                           maxlength="255"
                                           placeholder="nagios"
                                           type="text"
                                           id="Login">
                                    <div ng-repeat="error in errors.login">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>
                                </div>
                                <div class="form-group required" ng-class="{'has-error':errors.port}">
                                    <label class="control-label" for="Port">
                                        <?php echo __('Port'); ?>
                                    </label>
                                    <input ng-model="post.Satellite.port"
                                           class="form-control"
                                           placeholder="22"
                                           type="number"
                                           min="0"
                                           max="65535"
                                           step="1"
                                           id="Port">
                                    <div ng-repeat="error in errors.port">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>
                                    <div class="help-block">
                                        <?= __('SSH port of remote machine.') ?>
                                    </div>
                                </div>
                                <div class="form-group required" ng-class="{'has-error':errors.private_key_path}">
                                    <label class="control-label" for="PrivateKeyPath">
                                        <?php echo __('PrivateKeyPath'); ?>
                                    </label>
                                    <input ng-model="post.Satellite.private_key_path"
                                           class="form-control"
                                           placeholder="/var/lib/nagios/.ssh/id_rsa"
                                           type="text"
                                           id="PrivateKeyPath">
                                    <div ng-repeat="error in errors.private_key_path">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>
                                    <div class="help-block">
                                        <?= __('We will use a default path to private key if this field left empty') ?>
                                    </div>
                                </div>
                                <div class="form-group" ng-class="{'has-error': errors.remote_port}">
                                    <label class="control-label" for="RemotePort">
                                        <?php echo __('RemotePort'); ?>
                                    </label>
                                    <input ng-model="post.Satellite.remote_port"
                                           class="form-control"
                                           placeholder="4730"
                                           type="number"
                                           min="0"
                                           max="65535"
                                           step="1"
                                           id="RemotePort">
                                    <div ng-repeat="error in errors.remote_port">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>
                                    <div class="help-block">
                                        <?= __('Gearman port of remote machine.') ?>
                                    </div>
                                </div>
                            </div>
                            <div ng-switch-when="https_pull">
                                <div class="form-group required" ng-class="{'has-error': errors.url}">
                                    <label class="control-label" for="Url">
                                        <?php echo __('URL'); ?>
                                    </label>
                                    <div class="input-group">
                                        <div class="input-group-prepend">
                                            <button class="btn btn-primary text-white btn-outline-secondary dropdown-toggle"
                                                    type="button" data-toggle="dropdown"
                                                    aria-haspopup="true" aria-expanded="false">
                                                <i ng-class="(post.protocol == 'https')?'fas fa-lock':'fas fa-lock-open'"></i>
                                                {{post.protocol}}
                                            </button>
                                            <div class="dropdown-menu">
                                                <a class="dropdown-item" href="javascript:void(0);"
                                                   ng-click="post.protocol = 'https'">
                                                    <i class="fas fa-lock"></i>
                                                    https
                                                </a>

                                                <a class="dropdown-item" href="javascript:void(0);"
                                                   ng-click="post.protocol = 'http'">
                                                    <i class="fas fa-lock-open"></i>
                                                    http
                                                </a>
                                            </div>
                                        </div>
                                        <div class="input-group-prepend input-group-append">
                                            <span class="input-group-text">://</span>
                                        </div>
                                        <input ng-model="post.Satellite.address"
                                               class="form-control"
                                               readonly
                                               maxlength="255"
                                               type="text"
                                               id="Url">
                                        <div class="input-group-prepend input-group-append">
                                            <span class="input-group-text">/</span>
                                        </div>
                                        <input ng-model="post.frontendUrl"
                                               class="form-control w-50"
                                               maxlength="255"
                                               type="text"
                                               id="Url">
                                    </div>
                                    <div ng-repeat="error in errors.url">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>
                                </div>
                                <div class="form-group padding-top-10">
                                    <div class="custom-control custom-checkbox  margin-bottom-10">
                                        <input type="checkbox"
                                               class="custom-control-input"
                                               ng-true-value="1"
                                               ng-false-value="0"
                                               id="verifyCertificate"
                                               ng-model="post.Satellite.verify_certificate">
                                        <label class="custom-control-label" for="verifyCertificate">
                                            <?php echo __('Verify certificate'); ?>
                                        </label>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <div class="custom-control custom-checkbox  margin-bottom-10">
                                        <input type="checkbox"
                                               class="custom-control-input"
                                               ng-true-value="1"
                                               ng-false-value="0"
                                               id="enabledProxy"
                                               ng-model="post.Satellite.use_proxy">
                                        <label class="custom-control-label" for="enabledProxy">
                                            <?php echo __('Enable proxy'); ?>
                                        </label>
                                    </div>

                                    <div class="help-block">
                                        <?php echo __('If enabled the proxy server will be used.'); ?>
                                    </div>
                                </div>
                                <div class="form-group"
                                     ng-class="{'required':post.Satellite.use_proxy, 'has-error': errors.proxy_url}">
                                    <label class="control-label" for="proxyAddress">
                                        <?php echo __('Proxy URL'); ?>
                                    </label>
                                    <div class="input-group">
                                        <div class="input-group-prepend">
                                            <button class="btn btn-primary text-white btn-outline-secondary dropdown-toggle"
                                                    type="button" data-toggle="dropdown"
                                                    aria-haspopup="true" aria-expanded="false">
                                                <i ng-class="(post.proxyProtocol == 'https')?'fas fa-lock':'fas fa-lock-open'"></i>
                                                {{post.proxyProtocol}}
                                            </button>
                                            <div class="dropdown-menu">
                                                <a class="dropdown-item" href="javascript:void(0);"
                                                   ng-click="post.proxyProtocol = 'https'">
                                                    <i class="fas fa-lock"></i>
                                                    https
                                                </a>

                                                <a class="dropdown-item" href="javascript:void(0);"
                                                   ng-click="post.proxyProtocol = 'http'">
                                                    <i class="fas fa-lock-open"></i>
                                                    http
                                                </a>
                                            </div>
                                        </div>
                                        <div class="input-group-prepend input-group-append">
                                            <span class="input-group-text">://</span>
                                        </div>
                                        <input ng-model="post.proxyUrl"
                                               class="form-control"
                                               maxlength="255"
                                               type="text"
                                               id="proxyUrl">
                                    </div>
                                    <div ng-repeat="error in errors.proxy_url">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>
                                </div>
                                <div class="form-group required" ng-class="{'has-error': errors.api_key}">
                                    <label class="control-label" for="ApiKey">
                                        <?php echo __('API Key'); ?>
                                    </label>
                                    <div class="input-group">
                                        <input ng-model="post.Satellite.api_key"
                                               class="form-control"
                                               readonly
                                               maxlength="255"
                                               type="text"
                                               id="ApiKey">
                                        <div class="input-group-append">
                                            <button class="btn btn-success"
                                                    ng-click="createApiKey()"
                                                    type="button"
                                                    aria-haspopup="true" aria-expanded="false">
                                                <i class="fa fa-key"></i>
                                                <?= __('Create new API key'); ?>
                                            </button>
                                        </div>
                                    </div>

                                    <div ng-repeat="error in errors.api_key">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>
                                </div>
                                <div class="form-group" ng-class="{'has-error': errors.interval}">
                                    <label class="control-label" for="Interval">
                                        <?php echo __('Interval'); ?>
                                    </label>
                                    <input ng-model="post.Satellite.interval"
                                           class="form-control"
                                           type="number"
                                           placeholder="15"
                                           min="1"
                                           step="1"
                                           id="Interval">
                                    <div ng-repeat="error in errors.interval">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>
                                    <div class="help-block">
                                        <?= __('Time interval in seconds the master system will pickup check results') ?>
                                    </div>
                                </div>
                                <div class="form-group" ng-class="{'has-error': errors.timeout}">
                                    <label class="control-label" for="Timeout">
                                        <?php echo __('Timeout'); ?>
                                    </label>
                                    <input ng-model="post.Satellite.timeout"
                                           class="form-control"
                                           placeholder="300"
                                           type="number"
                                           min="1"
                                           step="1"
                                           id="Timeout">
                                    <div ng-repeat="error in errors.timeout">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>
                                    <div class="help-block">
                                        <?= __('Time limit in seconds which defines when the satellite should be marked as OFFLINE .') ?>
                                    </div>
                                </div>
                            </div>
                            <div ng-switch-when="https_push">
                                <div class="form-group required" ng-class="{'has-error': errors.api_key}">
                                    <label class="control-label" for="ApiKey">
                                        <?php echo __('API Key'); ?>
                                    </label>
                                    <div class="input-group">
                                        <input ng-model="post.Satellite.api_key"
                                               class="form-control"
                                               readonly
                                               maxlength="255"
                                               type="text"
                                               id="ApiKey">
                                        <div class="input-group-append">
                                            <button class="btn btn-success"
                                                    ng-click="createApiKey()"
                                                    type="button"
                                                    aria-haspopup="true" aria-expanded="false">
                                                <i class="fa fa-key"></i>
                                                <?= __('Create new API key'); ?>
                                            </button>
                                        </div>
                                    </div>

                                    <div ng-repeat="error in errors.api_key">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>
                                </div>
                                <div class="form-group required" ng-class="{'has-error': errors.timeout}">
                                    <label class="control-label" for="Timeout">
                                        <?php echo __('Timeout'); ?>
                                    </label>
                                    <input ng-model="post.Satellite.timeout"
                                           class="form-control"
                                           placeholder="300"
                                           min="1"
                                           step="1"
                                           type="number"
                                           id="Timeout">
                                    <div ng-repeat="error in errors.timeout">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>
                                    <div class="help-block">
                                        <?= __('Time limit in seconds which defines when the satellite should be marked as OFFLINE .') ?>
                                    </div>
                                </div>
                            </div>
                        </div>

                        <div class="form-group required" ng-class="{'has-error': errors.timezone}">
                            <label class="control-label" for="SatelliteTimezone">
                                <?php echo __('Timezone'); ?>
                            </label>
                            <select
                                    data-placeholder="<?php echo __('Please choose'); ?>"
                                    class="form-control"
                                    chosen="{}"
                                    id="SatelliteTimezone"
                                    ng-model="post.Satellite.timezone">
                                <?php foreach ($timezones as $continent => $continentTimezones): ?>
                                    <optgroup label="<?php echo h($continent); ?>">
                                        <?php foreach ($continentTimezones as $timezoneKey => $timezoneName): ?>
                                            <option
                                                    value="<?php echo h($timezoneKey); ?>"><?php echo h($timezoneName); ?></option>
                                        <?php endforeach; ?>
                                    </optgroup>
                                <?php endforeach; ?>
                            </select>
                            <div ng-repeat="error in errors.timezone">
                                <div class="help-block text-danger">{{ error }}</div>
                            </div>
                        </div>
                        <div class="form-group padding-top-10">
                            <div class="custom-control custom-checkbox  margin-bottom-10">
                                <input type="checkbox"
                                       class="custom-control-input"
                                       ng-true-value="1"
                                       ng-false-value="0"
                                       id="timeSyncing"
                                       ng-model="post.Satellite.use_timesync">
                                <label class="custom-control-label" for="timeSyncing">
                                    <?php echo __('Time Syncing'); ?>
                                </label>
                            </div>
                            <div class="help-block">
                                <?php echo __('Determines if you want to synchronise the system clock of the master server to the satellite system.
Notice: It is not recommended to enable this option. Please use a NTP server whenever possible.'); ?>
                            </div>
                        </div>
                        <div class="card margin-top-10">
                            <div class="card-body">
                                <div class="float-right">
                                    <button class="btn btn-primary" type="submit">
                                        <?php echo __('Update satellite'); ?>
                                    </button>
                                    <a back-button href="javascript:void(0);" fallback-state='SatellitesIndex'
                                       class="btn btn-default">
                                        <?php echo __('Cancel'); ?>
                                    </a>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>