<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
//
// 2.
//	If you purchased an openITCOCKPIT Enterprise Edition you can use this file
//	under the terms of the openITCOCKPIT Enterprise Edition license agreement.
//	License agreement and license key will be shipped with the order
//	confirmation.

$SatSyncMethods = new \DistributeModule\Lib\SatSyncMethods();

?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?php echo __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fas fa-puzzle-piece"></i> <?php echo __('Distribute Module'); ?>
    </li>
    <li class="breadcrumb-item">
        <a ui-sref="SatellitesIndex">
            <i class="fas fa-satellite"></i> <?php echo __('Satellites'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fas fa-satellite-dish"></i> <?php echo __('Status overview'); ?>
    </li>
</ol>

<!-- ANGAULAR DIRECTIVES -->
<massdelete></massdelete>

<div class="row">
    <div class="col-xl-12">
        <div id="panel-1" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('Satellites'); ?>
                    <span class="fw-300"><i><?php echo __('Status overview'); ?></i></span>
                </h2>
                <div class="panel-toolbar">
                    <button class="btn btn-xs btn-default mr-1 shadow-0" ng-click="load()">
                        <i class="fas fa-sync"></i> <?php echo __('Refresh'); ?>
                    </button>
                    <?php if ($this->Acl->hasPermission('add', 'satellites', 'DistributeModule')): ?>
                        <button class="btn btn-xs btn-success mr-1 shadow-0" ui-sref="SatellitesAdd">
                            <i class="fas fa-plus"></i> <?php echo __('New'); ?>
                        </button>
                    <?php endif; ?>

                    <button class="btn btn-xs btn-primary shadow-0" ng-click="triggerFilter()">
                        <i class="fas fa-filter"></i> <?php echo __('Filter'); ?>
                    </button>
                </div>
            </div>
            <div class="panel-container show">
                <div class="panel-content">

                    <!-- Start Filter -->
                    <div class="list-filter card margin-bottom-10" ng-show="showFilter">
                        <div class="card-header">
                            <i class="fa fa-filter"></i> <?php echo __('Filter'); ?>
                        </div>
                        <div class="card-body">
                            <div class="row">
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fa fa-filter"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by satellite name'); ?>"
                                                   ng-model="filter.Satellites.name"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fa fa-filter"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by IP address'); ?>"
                                                   ng-model="filter.Satellites.address"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group input-group-sm">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fa fa-filter"></i></span>
                                            </div>
                                            <select
                                                    id="hostFilter"
                                                    data-placeholder="<?php echo __('Filter by sync method'); ?>"
                                                    class="form-control"
                                                    chosen="{}"
                                                    multiple
                                                    ng-model="filter.Satellites.sync_method">
                                                <?php foreach ($SatSyncMethods->getSyncMethods() as $key => $name): ?>
                                                    <option value="<?= h($key) ?>"><?= h($name) ?></option>
                                                <?php endforeach; ?>
                                            </select>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group input-group-sm">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fa fa-filter"></i></span>
                                            </div>
                                            <select
                                                    data-placeholder="<?php echo __('Filter by sync status'); ?>"
                                                    class="form-control"
                                                    chosen="{}"
                                                    multiple
                                                    ng-model="filter.status">
                                                <option value="0"><?= __('Unknown'); ?></option>
                                                <option value="1"><?= __('Success'); ?></option>
                                                <option value="2"><?= __('Error'); ?></option>
                                            </select>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="float-right">
                                <button type="button" ng-click="resetFilter()"
                                        class="btn btn-xs btn-danger">
                                    <?php echo __('Reset Filter'); ?>
                                </button>
                            </div>
                        </div>
                    </div>
                    <!-- Filter End -->

                    <div class="frame-wrap">
                        <table class="table table-striped m-0 table-bordered table-hover table-sm">
                            <thead>
                            <tr>
                                <th class="no-sort" ng-click="orderBy('Satellites.name')">
                                    <i class="fa" ng-class="getSortClass('Satellites.name')"></i>
                                    <?php echo __('Instance name'); ?>
                                </th>
                                <th class="no-sort" ng-click="orderBy('Satellites.address')">
                                    <i class="fa" ng-class="getSortClass('Satellites.address')"></i>
                                    <?php echo __('IP address'); ?>
                                </th>
                                <th class="no-sort" ng-click="orderBy('Satellites.sync_method')">
                                    <i class="fa" ng-class="getSortClass('Satellites.sync_method')"></i>
                                    <?php echo __('Sync method'); ?>
                                </th>

                                <th class="no-sort" ng-click="orderBy('status')">
                                    <i class="fa" ng-class="getSortClass('status')"></i>
                                    <?php echo __('Sync status'); ?>
                                </th>

                                <th class="no-sort" ng-click="orderBy('SatelliteStatus.last_export')">
                                    <i class="fa" ng-class="getSortClass('SatelliteStatus.last_export')"></i>
                                    <?php echo __('Last sync'); ?>
                                </th>

                                <th class="no-sort" ng-click="orderBy('SatelliteStatus.last_seen')">
                                    <i class="fa" ng-class="getSortClass('SatelliteStatus.last_seen')"></i>
                                    <?php echo __('Last seen'); ?>
                                </th>

                                <th class="no-sort" ng-click="orderBy('SatelliteStatus.last_error')">
                                    <i class="fa" ng-class="getSortClass('SatelliteStatus.last_error')"></i>
                                    <?php echo __('Last error'); ?>
                                </th>
                            </tr>
                            </thead>
                            <tbody>
                            <tr ng-repeat="satellite in satellites">
                                <td>
                                    {{ satellite.name }}
                                </td>
                                <td>
                                    {{ satellite.address }}
                                </td>
                                <td>
                                    {{ satellite.sync_method_name }}
                                </td>
                                <td>
                                    <span class="label-forced margin-right-5" title="{{ satellite.satellite_status.status_human }}"
                                    ng-class="{'badge-success': satellite.status === 1, 'badge-danger': satellite.status === 2, 'badge-secondary': satellite.status === 0}">
                                       {{ satellite.satellite_status.status_human }}
                                    </span>
                                </td>
                                <td>
                                    {{ satellite.satellite_status.last_export }}
                                </td>
                                <td>
                                    {{ satellite.satellite_status.last_seen }}
                                </td>
                                <td class="text-danger">
                                    {{ satellite.satellite_status.last_error }}
                                </td>
                            </tr>
                            </tbody>
                        </table>
                        <div class="margin-top-10" ng-show="satellites.length == 0">
                            <div class="text-center text-danger italic">
                                <?php echo __('No entries match the selection'); ?>
                            </div>
                        </div>

                        <scroll scroll="scroll" click-action="changepage" ng-if="scroll"></scroll>
                        <paginator paging="paging" click-action="changepage" ng-if="paging"></paginator>
                        <?php echo $this->element('paginator_or_scroll'); ?>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>