<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

$timezones = \itnovum\openITCOCKPIT\Core\Timezone::listTimezones();
?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?php echo __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fas fa-puzzle-piece"></i> <?php echo __('Distribute Module'); ?>
    </li>
    <li class="breadcrumb-item">
        <a ui-sref="SatellitesIndex">
            <i class="fas fa-satellite"></i> <?php echo __('Satellites'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fa fa-code-fork"></i> <?php echo __('Used by'); ?>
    </li>
</ol>


<div class="row">
    <div class="col-xl-12">
        <div id="panel-1" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('Satellite'); ?>
                    <span class="fw-300">
                        <i>
                            <strong>
                                »{{ satellite.name }}«
                            </strong>
                            <?php echo __('is used by'); ?>
                            {{ all_hosts.length }}
                            <?php echo __('hosts.'); ?>
                        </i>
                    </span>
                </h2>
                <div class="panel-toolbar">
                    <?php if ($this->Acl->hasPermission('index', 'satellites', 'DistributeModule')): ?>
                        <a back-button href="javascript:void(0);" fallback-state='SatellitesIndex' class="btn btn-default btn-xs mr-1 shadow-0">
                            <i class="fas fa-long-arrow-alt-left"></i> <?php echo __('Back'); ?>
                        </a>
                    <?php endif; ?>
                </div>
            </div>
            <div class="panel-container show">
                <div class="panel-content">
                    <table id="usedby_list" class="table table-striped m-0 table-bordered table-hover table-sm">
                        <tbody>
                        <tr ng-if="all_hosts.length > 0">
                            <th class="bg-color-lightGray">
                                <i class="fa fa-desktop"></i>
                                <?php echo __('Hosts'); ?> ({{all_hosts.length}})
                            </th>
                        </tr>
                        <tr ng-repeat="host in all_hosts">
                            <td>
                                <?php if ($this->Acl->hasPermission('browser', 'hosts', '')): ?>
                                    <a ui-sref="HostsBrowser({id: host.id})">
                                        {{ host.hostname }} ({{host.address}})
                                    </a>
                                <?php else: ?>
                                    {{ host.hostname }} ({{host.address}})
                                <?php endif; ?>
                            </td>
                        </tr>
                        </tbody>
                    </table>
                    <div class="row margin-top-10 margin-bottom-10" ng-show="all_hosts == 0">
                        <div class="col-lg-12 d-flex justify-content-center txt-color-red italic">
                            <?php echo __('This satellite is not used by any host'); ?>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>