angular.module('openITCOCKPIT')
    .controller('SatellitesStatusController', function($scope, $http, SortService){

        SortService.setSort('Satellites.name');
        SortService.setDirection('asc');
        $scope.currentPage = 1;
        $scope.useScroll = true;

        /*** Filter Settings ***/
        var defaultFilter = function(){
            $scope.filter = {
                Satellites: {
                    name: '',
                    address: '',
                    sync_method: []
                },
                status: []
            };
        };
        /*** Filter end ***/

        $scope.init = true;
        $scope.showFilter = false;
        $scope.load = function(){
            $http.get("/distribute_module/satellites/status.json", {
                params: {
                    'angular': true,
                    'scroll': $scope.useScroll,
                    'sort': SortService.getSort(),
                    'page': $scope.currentPage,
                    'direction': SortService.getDirection(),
                    'filter[Satellites.name]': $scope.filter.Satellites.name,
                    'filter[Satellites.address]': $scope.filter.Satellites.address,
                    'filter[Satellites.sync_method][]': $scope.filter.Satellites.sync_method,
                    'filter[status][]': $scope.filter.status
                }
            }).then(function(result){
                $scope.satellites = result.data.all_satellites;
                $scope.paging = result.data.paging;
                $scope.scroll = result.data.scroll;
                $scope.init = false;
            });
        };

        $scope.triggerFilter = function(){
            $scope.showFilter = !$scope.showFilter === true;
        };

        $scope.resetFilter = function(){
            defaultFilter();
            $scope.undoSelection();
        };


        $scope.changeMode = function(val){
            $scope.useScroll = val;
            $scope.load();
        };

        $scope.changepage = function(page){
            if(page !== $scope.currentPage){
                $scope.currentPage = page;
                $scope.load();
            }
        };

        //Fire on page load
        defaultFilter();
        SortService.setCallback($scope.load);

        $scope.$watch('filter', function(){
            $scope.load();
        }, true);

    });
